<template>
  <v-layout row justify-center display: flex style="margin-top: 65px;">
        <v-navigation-drawer
      width="620"
      v-model="transactionmodal"
      fixed
      right
      clipped
    >
          <v-btn flat small style="color:#538795;" @click="transactionmodal = false"><v-icon>close</v-icon>CLOSE</v-btn>
          <p class="font-size-20-bold" align="center" style="margin-bottom:0px;" >Transaction</p><br>

          <v-layout px-3>
          <!-- <div align="left" v-if="!mobileView"> -->
            <v-flex md6>
            <p  v-if="!mobileView" style="margin-bottom:0px;">Transaction No.  &nbsp; <span style="font-weight:bold; color:#538795;">{{ transview.transaction_ref }}</span></p>
            </v-flex>
            <v-flex md6>
              <p  v-if="!mobileView" style="margin-bottom:0px;">Payment Transaction No.  <span style="font-weight:bold; color:#538795;">{{ transview.payment_transaction_no }}</span></p>
            </v-flex>
          <!-- </div> -->
          </v-layout>
          <v-layout px-3 py-2 v-if="!mobileView">
          <!-- <div align="left" v-if="!mobileView"> -->
            <v-flex md6 py-2>
            <p  v-if="!mobileView" style="margin-bottom:0px;">Transaction Date <span style="font-weight:bold; color:#538795;">{{ transview.transdate  }}</span></p>
            </v-flex>
            <v-flex md6>
              <p v-if="!mobileView" style="margin-bottom:0px;">Payment Result &emsp;&emsp;&emsp;&emsp; <v-chip
                :color="transactiondata.rcode === '0' ? 'success' : (transactiondata.rcode === '1' ? 'red' : transactiondata.rcode ==='2' ? 'warning':'grey')"
                v-if="transactiondata.rcode"
                text-color="white"
                text-size="117%"
                style="width:70px; justify-content: center;"
              >{{ transactiondata.status }}</v-chip>
              </p>
            </v-flex>

          </v-layout>
          <!-- Mobile View -->
          <div v-if="mobileView">
            <p style="font-size:14px; font-family:Sarabun; margin-left:20px;" align="left" v-if="mobileView">
              Transaction No. : <strong style="color:#538795;">{{ transview.transaction_ref }}</strong> <br>
              Payment Transaction No. : <strong style="color:#538795;">{{ transview.payment_transaction_no }}</strong><br>
              Transaction Date : <strong style="color:#538795;">{{ transview.transdate  }}</strong><br>
              Payment Result : <strong style="color:#538795;">
                <v-chip
                :color="transactiondata.rcode === '0' ? 'success' : (transactiondata.rcode === '1' ? 'red' : transactiondata.rcode ==='2' ? 'warning':'grey')"
                v-if="transactiondata.rcode"
                text-color="white"
                text-size="117%"
                style="width:70px; justify-content: center;"
              >{{ transactiondata.status }}</v-chip>
              </strong><br>
              <span style="color:red; font-size:12px;">*Click on invoice number to see the detail</span>
            </p>
          </div>
        <v-layout align-center justify-center row wrap>
          <v-flex xs11 px-1>
            <v-data-table
              class="elevation-3"
              :headers="headers"
              :items="invoiceview"
              item-key="invoice_no"
              hide-actions
              id="tableDetail"
            >
              <template v-slot:items="props" class="tmodal_data">
                <tr style="cursor: pointer;" @click="openinvoicemodal(props.item.invoice_no)">
                  <td class="text-xs-right" data-label="No." >{{ props.index + 1}}</td>
                  <td data-label="Invoice No"><span style="text-decoration:underline; color:#538795;">{{ props.item.invoice_no }}</span></td>
                  <td data-label="Invoice Date">{{ props.item.date }}</td>
                  <td data-label="Amount">{{ props.item.amount }}</td>
                </tr>
              </template>
            </v-data-table>
          </v-flex>
        </v-layout>
        <v-layout align-center justify-end row wrap px-3 py-3>
            <v-flex xs10  px-4>
              <p class="font-size-14 font-roboto" align="right" v-if="!mobileView">
                <strong >Payment Amount (THB) &nbsp;&nbsp;</strong>
              </p>
            </v-flex>
            <v-flex xs2 py-4>
              <p class="font-size-14 font-roboto" align="right" v-if="!mobileView">
                <strong >{{ transview.amount }} &nbsp;&nbsp;</strong>
              </p>
            </v-flex>
            <div>
            <p class="font-size-14 font-roboto" style="margin-right:10px;" align="right" v-if="mobileView">
              <strong>Payment Amount (THB) &nbsp;&nbsp; {{ transview.amount }}</strong>
            </p>
          </div>
          </v-layout>

        <v-flex pb-5></v-flex>
      <!-- </v-card> -->
    <!-- </v-dialog> -->
    </v-navigation-drawer>
    <!-- <Invoicemodal /> -->
    <InvoiceofTransaction />
  </v-layout>
</template>

<script>
import { sync } from 'vuex-pathify'
// import Invoicemodal from '@/components/Invoicemodal'
// import InvoiceofTransaction from '@/components/InvoiceofTransaction'
import moment from 'moment'
moment.locale('en')
export default {
  components: {
    // InvoiceofTransaction
  },
  data () {
    return {
      mobileView: false,
      dialogloader: false,
      notifications: false,
      sound: true,
      widgets: false,
      transactiondata: [],
      invoicedata: [],
      tempinvoices: [],
      headers: [
        { text: 'No.', value: 'index', sortable: false, align: 'right' },
        {
          text: 'Invoice No.',
          value: 'invoice_no',
          align: 'left'
        },
        {
          text: 'Invoice Date',
          value: 'Start_date',
          align: 'left'
        },
        {
          text: 'Amount',
          value: 'Invoice_amount',
          align: 'left'
        }
      ]
    }
  },
  methods: {
    openinvoicemodal (invoiceno) {
      this.currentinvoiceno = invoiceno
      // this.invoicemodal = true
      this.$cookies.get('transno')
      // console.log('hi')
      this.invoiceoftransaction = true
    },
    async gettransactiondata () {
      if (this.currenttransaction) {
        try {
          this.istableloading = true
          // let buff = new Buffer(this.currenttransaction.toString());
          let { data } = await this.axios.get(`${process.env.VUE_APP_APIHOST}/transaction/`+this.currenttransaction, {
            headers: {
              Authorization: this.$cookies.get('token')
            }
          })
          // console.log('/transaction: ', data)
          this.transactiondata = data.transaction
          this.invoicedata = data.invoices
          this.istableloading = false
        } catch (error) {
          this.istableloading = false
          console.log(error.message)
        }
      }
    },
    addCommas (nStr) {
      nStr += ''
      var x = nStr.split('.')
      var x1 = x[0]
      var x2 = x.length > 1 ? '.' + x[1] : ''
      var rgx = /(\d+)(\d{3})/
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2')
      }
      return x1 + x2
    },
    handleView () {
      this.mobileView = window.innerWidth <= 990
      this.$cookies.set('screenView', this.mobileView)
    }
  },
  computed: {
    transactionmodal: sync('transactionmodal'),
    currenttransaction: sync('currenttransaction'),
    invoiceoftransaction: sync('invoiceoftransaction'),
    currentinvoiceno: sync('currentinvoiceno'),
    invoiceview () {
      return this.invoicedata.map(inv => {
        return {
          ...inv,
          date: moment(inv.invoice_date).format('D MMMM YYYY'),
          amount: this.addCommas(inv.total_amount.toFixed(2)) + ' THB'
        }
      })
    },
    transview () {
      return {
        ...this.transactiondata,
        transdate: moment(`${this.transactiondata.transaction_date} ${this.transactiondata.transaction_time}`).format(
          'D MMMM YYYY, HH:mm:ss'
        ),
        amount: this.addCommas(
          parseFloat(this.transactiondata.total_amount).toFixed(2)
        ),
        paymentdate: moment(this.transactiondata.updatedAt).format(
          'D MMMM YYYY, HH:mm:ss'
        )
      }
    }
  },
  watch: {
    currenttransaction () {
      this.gettransactiondata()
    }
  },
  created () {
    this.gettransactiondata()
    this.handleView()
  }
}
</script>
<style>
</style>
